#include "cgars.h"
#include <stdlib.h>

using namespace std;

string commands = "      SYNOPSIS \n \t cgars [command] <options>\n\n \
     COMMANDS:\n \
     \t analyze     \t analyze copy number data\n\
     \t plot        \t plot copy number aberrations (requires R)\n";


int main(int argc,char *argv[])
{
  string command;

  //declaration of main class object
  try
    {
      mainCLS cgars;

      if(argc==1)
	{
	  print_header();
	  throw commands;
	}

      command=(string)argv[1];

      if(command=="analyze")
	{
	  cgars.parse_analyze(argc,argv);
	  cgars.readRawCN();
	  cgars.readSeg();
	  cgars.computeRanks();
	  cgars.computeRankSum();
	  cgars.segmentRankSum();
	  cgars.leaveOut();
	  cgars.computeStats();
	  cgars.writeOutput();
	}
      else if(command=="plot")
	{
	  cgars.plot(argc,argv);
	}
      else
	{
	  print_header();
	  throw commands;
	}

    }
  catch(string err)
    {
      cerr << err << endl;
      exit(1);
    }
}
